#!/usr/bin/php
<?php
if (isset($_SERVER['REMOTE_ADDR'])) {
    die('Direct access not permitted');
}

$DATADIR = '/srv/http/metern/data/';

// Set the household export meter ID and command
$EEXPID      = 'EEXP'; // Meter ID
$EXPmetnum   = 6; // Meter number
$EXPcmd    = 'more /tmp/485metern.txt | egrep "^EEXP\(" | grep "*Wh)"'; // Energy command
// Same for the household production
$HHPID       = '4';
$PRODmetnum  = 4;
$PRODcmd     = 'pool123s energy';
// Selfconsumption meter number
$SELFCmetnum = 7;

// No edit should be needed bellow

function isvalid($id, $datareturn) //  IEC 62056 data set structure
{
    $regexp = "/^$id\(-?[0-9\.]+\*[A-z0-9³²%°]+\)$/i"; //ID(VALUE*UNIT)
    if (preg_match($regexp, $datareturn)) {
        $datareturn = preg_replace("/^$id\(/i", '', $datareturn, 1); // VALUE*UNIT)
        $datareturn = preg_replace("/\*[A-z0-9³²%°]+\)$/i", '', $datareturn, 1); // VALUE
        settype($datareturn, 'int');
    } else {
        $datareturn = null;
    }
    return $datareturn;
}

define('checkaccess', TRUE);
include('../config/config_main.php');
date_default_timezone_set($DTZ);

include("../config/config_met$EXPmetnum.php");
include("../config/config_met$PRODmetnum.php");
include("../config/config_met$SELFCmetnum.php");

$dir    = '../data/csv';
$output = array();
$output = glob($dir . '/*.csv');
sort($output);
$cnt = count($output);

if (file_exists($output[$cnt - 1])) {
    $lines      = file($output[$cnt - 1]); // today
    $contalines = count($lines);
    if ($contalines > 2) {
        $lastarray = preg_split("/,/", $lines[$contalines - 1]);
        
        $year  = substr($output[$cnt - 1], -12, 4);
        $month = substr($output[$cnt - 1], -8, 2);
        $day   = substr($output[$cnt - 1], -6, 2);
    } elseif ($contalines == 1 && file_exists($output[$cnt - 2])) { // yesterday, only header
        $lines      = file($output[$cnt - 2]);
        $contalines = count($lines);
        
        $lastarray = preg_split("/,/", $lines[$contalines - 1]);
        
        $year  = substr($output[$cnt - 2], -12, 4);
        $month = substr($output[$cnt - 2], -8, 2);
        $day   = substr($output[$cnt - 2], -6, 2);
    } elseif ($contalines == 2 && file_exists($output[$cnt - 2])) { // yesterday, header + only one data line	
        $lastarray = preg_split("/,/", $lines[$contalines - 1]);
        
        $lines      = file($output[$cnt - 2]);
        $contalines = count($lines);
        $prevarray  = preg_split("/,/", $lines[$contalines - 2]);
        
        $year  = substr($output[$cnt - 1], -12, 4);
        $month = substr($output[$cnt - 1], -8, 2);
        $day   = substr($output[$cnt - 1], -6, 2);
    } else {
        $year  = 0;
        $month = 0;
        $day   = 0;
    }
    
    $hour    = substr($lastarray[0], 0, 2);
    $min     = substr($lastarray[0], 3, 2);
    $UTCdate = strtotime($year . '-' . $month . '-' . $day . ' ' . $hour . ':' . $min);
    
    $nowutc = strtotime(date('Ymd H:i:s'));
    
    if ($nowutc - $UTCdate < 360) {
        $datareturn     = null;
        $val            = null;
        $export         = null;
        $production     = null;
        $prod_lastcsv   = null;
        $export_lastcsv = null;
        // Retrieve export
        $datareturn = exec($EXPcmd);
        $datareturn = trim($datareturn);
        $export     = isvalid($EEXPID, $datareturn);
        
        // Retrieve production
	$datareturn     = null;
        $datareturn = exec($PRODcmd);
        $datareturn = trim($datareturn);
        $production = isvalid($HHPID, $datareturn);
        
        if (isset($export) && isset($production)) {
            $prod_lastcsv   = trim($lastarray[$PRODmetnum]);
            $export_lastcsv = trim($lastarray[$EXPmetnum]);
            
            if ($lastarray[$SELFCmetnum] == '' || $export_lastcsv == '' || $prod_lastcsv == '') {
                $lastarray[$SELFCmetnum] = null;
            }
            if (isset($lastarray[$SELFCmetnum]) && isset($prod_lastcsv) && isset($export_lastcsv)) { // Avoid null values if skipped or missing a data
                settype($prod_lastcsv, 'int');
                settype($export_lastcsv, 'int');
                
                if ($production >= $prod_lastcsv) {
                    $production -= $prod_lastcsv;
                } else { // counter pass over
                    $production += ${'PASSO' . $PRODmetnum} - $prod_lastcsv;
                }
                
                if ($export >= $export_lastcsv) {
                    $export -= $export_lastcsv;
                } else {
                    $export += ${'PASSO' . $EXPmetnum} - $export_lastcsv;
                }
                
                if ($export > 0) {
                    $val = $production - $export;
                } else {
                    $val = $production;
                }
                settype($lastarray[$SELFCmetnum], 'int');
                settype($val, 'int');
                $val += $lastarray[$SELFCmetnum];
                if ($val > ${'PASSO' . $SELFCmetnum}) {
                    $val -= ${'PASSO' . $SELFCmetnum};
                }
            } else { // Retrieve the last know value
                $val = null;
                $j   = 0;
                while (!isset($val)) {
                    $j++;
                    $array = preg_split('/,/', $lines[$contalines - $j]);
                    $val   = trim($array[$SELFCmetnum]);
                    if ($val == '') {
                        $val = null;
                    }
                    if ($j == $contalines - 1) {
                        $val = 0;
                    }
                }
            }
            $str = utf8_decode("$SELFCmetnum($val*Wh)\n");
            echo "$str";
        } else {
            die("Error: Retriving latest values\n");
        }
    } else {
        die("Error: Too late date value in csv\n");
    }
} else {
    die("Error: No csv file\n");
}
?>
